diff -NurpP --minimal linux-3.0/arch/sh/Kconfig torvalds-linux-v3.1-rc10/arch/sh/Kconfig
--- linux-3.0/arch/sh/Kconfig	2011-08-29 03:04:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -11,6 +11,7 @@ config SUPERH
 	select HAVE_DMA_ATTRS
 	select HAVE_IRQ_WORK
 	select HAVE_PERF_EVENTS
+	select ARCH_HAVE_NMI_SAFE_CMPXCHG if (GUSA_RB || CPU_SH4A)
 	select PERF_USE_VMALLOC
 	select HAVE_KERNEL_GZIP
 	select HAVE_KERNEL_BZIP2
@@ -897,20 +898,4 @@ source "security/Kconfig"
 
 source "crypto/Kconfig"
 
-menuconfig VIRTUALIZATION
-	bool "Virtualization"
-	default n
-	---help---
-	  Say Y here to get to see options for using your Linux host to run other
-	  operating systems inside virtual machines (guests).
-	  This option alone does not add any kernel code.
-
-	  If you say N, all options in this submenu will be skipped and disabled.
-
-if VIRTUALIZATION
-
-source drivers/virtio/Kconfig
-
-endif # VIRTUALIZATION
-
 source "lib/Kconfig"
diff -NurpP --minimal linux-3.0/arch/sh/Makefile torvalds-linux-v3.1-rc10/arch/sh/Makefile
--- linux-3.0/arch/sh/Makefile	2011-04-03 18:50:36.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/Makefile	2011-10-18 04:06:23.000000000 +0000
@@ -173,6 +173,7 @@ core-$(CONFIG_HD6446X_SERIES)	+= arch/sh
 cpuincdir-$(CONFIG_CPU_SH2A)	+= cpu-sh2a
 cpuincdir-$(CONFIG_CPU_SH2)	+= cpu-sh2
 cpuincdir-$(CONFIG_CPU_SH3)	+= cpu-sh3
+cpuincdir-$(CONFIG_CPU_SH4A)	+= cpu-sh4a
 cpuincdir-$(CONFIG_CPU_SH4)	+= cpu-sh4
 cpuincdir-$(CONFIG_CPU_SH5)	+= cpu-sh5
 cpuincdir-y			+= cpu-common	# Must be last
diff -NurpP --minimal linux-3.0/arch/sh/boards/board-apsh4a3a.c torvalds-linux-v3.1-rc10/arch/sh/boards/board-apsh4a3a.c
--- linux-3.0/arch/sh/boards/board-apsh4a3a.c	2011-04-03 18:50:36.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/board-apsh4a3a.c	2011-10-18 04:06:23.000000000 +0000
@@ -116,7 +116,7 @@ static int apsh4a3a_clk_init(void)
 	int ret;
 
 	clk = clk_get(NULL, "extal");
-	if (!clk || IS_ERR(clk))
+	if (IS_ERR(clk))
 		return PTR_ERR(clk);
 	ret = clk_set_rate(clk, 33333000);
 	clk_put(clk);
diff -NurpP --minimal linux-3.0/arch/sh/boards/board-apsh4ad0a.c torvalds-linux-v3.1-rc10/arch/sh/boards/board-apsh4ad0a.c
--- linux-3.0/arch/sh/boards/board-apsh4ad0a.c	2011-04-03 18:50:36.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/board-apsh4ad0a.c	2011-10-18 04:06:23.000000000 +0000
@@ -94,7 +94,7 @@ static int apsh4ad0a_clk_init(void)
 	int ret;
 
 	clk = clk_get(NULL, "extal");
-	if (!clk || IS_ERR(clk))
+	if (IS_ERR(clk))
 		return PTR_ERR(clk);
 	ret = clk_set_rate(clk, 33333000);
 	clk_put(clk);
diff -NurpP --minimal linux-3.0/arch/sh/boards/board-sh7785lcr.c torvalds-linux-v3.1-rc10/arch/sh/boards/board-sh7785lcr.c
--- linux-3.0/arch/sh/boards/board-sh7785lcr.c	2011-04-03 18:50:36.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/board-sh7785lcr.c	2011-10-18 04:06:23.000000000 +0000
@@ -299,7 +299,7 @@ static int sh7785lcr_clk_init(void)
 	int ret;
 
 	clk = clk_get(NULL, "extal");
-	if (!clk || IS_ERR(clk))
+	if (IS_ERR(clk))
 		return PTR_ERR(clk);
 	ret = clk_set_rate(clk, 33333333);
 	clk_put(clk);
diff -NurpP --minimal linux-3.0/arch/sh/boards/board-urquell.c torvalds-linux-v3.1-rc10/arch/sh/boards/board-urquell.c
--- linux-3.0/arch/sh/boards/board-urquell.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/board-urquell.c	2011-10-18 04:06:23.000000000 +0000
@@ -190,7 +190,7 @@ static int urquell_clk_init(void)
 		return -EINVAL;
 
 	clk = clk_get(NULL, "extal");
-	if (!clk || IS_ERR(clk))
+	if (IS_ERR(clk))
 		return PTR_ERR(clk);
 	ret = clk_set_rate(clk, 33333333);
 	clk_put(clk);
diff -NurpP --minimal linux-3.0/arch/sh/boards/mach-ap325rxa/setup.c torvalds-linux-v3.1-rc10/arch/sh/boards/mach-ap325rxa/setup.c
--- linux-3.0/arch/sh/boards/mach-ap325rxa/setup.c	2011-08-29 03:04:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/mach-ap325rxa/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -188,7 +188,7 @@ static void ap320_wvga_power_off(void *b
 	__raw_writew(0, FPGA_LCDREG);
 }
 
-const static struct fb_videomode ap325rxa_lcdc_modes[] = {
+static const struct fb_videomode ap325rxa_lcdc_modes[] = {
 	{
 		.name = "LB070WV1",
 		.xres = 800,
@@ -332,8 +332,8 @@ static int camera_set_capture(struct soc
 	return ret;
 }
 
-static int ap325rxa_camera_add(struct soc_camera_link *icl, struct device *dev);
-static void ap325rxa_camera_del(struct soc_camera_link *icl);
+static int ap325rxa_camera_add(struct soc_camera_device *icd);
+static void ap325rxa_camera_del(struct soc_camera_device *icd);
 
 static struct soc_camera_platform_info camera_info = {
 	.format_name = "UYVY",
@@ -366,24 +366,23 @@ static void ap325rxa_camera_release(stru
 	soc_camera_platform_release(&camera_device);
 }
 
-static int ap325rxa_camera_add(struct soc_camera_link *icl,
-			       struct device *dev)
+static int ap325rxa_camera_add(struct soc_camera_device *icd)
 {
-	int ret = soc_camera_platform_add(icl, dev, &camera_device, &camera_link,
+	int ret = soc_camera_platform_add(icd, &camera_device, &camera_link,
 					  ap325rxa_camera_release, 0);
 	if (ret < 0)
 		return ret;
 
 	ret = camera_probe();
 	if (ret < 0)
-		soc_camera_platform_del(icl, camera_device, &camera_link);
+		soc_camera_platform_del(icd, camera_device, &camera_link);
 
 	return ret;
 }
 
-static void ap325rxa_camera_del(struct soc_camera_link *icl)
+static void ap325rxa_camera_del(struct soc_camera_device *icd)
 {
-	soc_camera_platform_del(icl, camera_device, &camera_link);
+	soc_camera_platform_del(icd, camera_device, &camera_link);
 }
 #endif /* CONFIG_I2C */
 
diff -NurpP --minimal linux-3.0/arch/sh/boards/mach-ecovec24/setup.c torvalds-linux-v3.1-rc10/arch/sh/boards/mach-ecovec24/setup.c
--- linux-3.0/arch/sh/boards/mach-ecovec24/setup.c	2011-08-29 03:04:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/mach-ecovec24/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -280,7 +280,7 @@ static struct platform_device usbhs_devi
 };
 
 /* LCDC */
-const static struct fb_videomode ecovec_lcd_modes[] = {
+static const struct fb_videomode ecovec_lcd_modes[] = {
 	{
 		.name		= "Panel",
 		.xres		= 800,
@@ -295,7 +295,7 @@ const static struct fb_videomode ecovec_
 	},
 };
 
-const static struct fb_videomode ecovec_dvi_modes[] = {
+static const struct fb_videomode ecovec_dvi_modes[] = {
 	{
 		.name		= "DVI",
 		.xres		= 1280,
diff -NurpP --minimal linux-3.0/arch/sh/boards/mach-highlander/setup.c torvalds-linux-v3.1-rc10/arch/sh/boards/mach-highlander/setup.c
--- linux-3.0/arch/sh/boards/mach-highlander/setup.c	2011-04-03 18:50:36.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/mach-highlander/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -335,8 +335,6 @@ static struct clk *r7780rp_clocks[] = {
 	&ivdr_clk,
 };
 
-#define CLKDEV_CON_ID(_id, _clk) { .con_id = _id, .clk = _clk }
-
 static struct clk_lookup lookups[] = {
 	/* main clocks */
 	CLKDEV_CON_ID("ivdr_clk", &ivdr_clk),
diff -NurpP --minimal linux-3.0/arch/sh/boards/mach-kfr2r09/setup.c torvalds-linux-v3.1-rc10/arch/sh/boards/mach-kfr2r09/setup.c
--- linux-3.0/arch/sh/boards/mach-kfr2r09/setup.c	2011-06-22 15:08:12.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/mach-kfr2r09/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -127,7 +127,7 @@ static struct platform_device kfr2r09_sh
 	},
 };
 
-const static struct fb_videomode kfr2r09_lcdc_modes[] = {
+static const struct fb_videomode kfr2r09_lcdc_modes[] = {
 	{
 		.name = "TX07D34VM0AAA",
 		.xres = 240,
diff -NurpP --minimal linux-3.0/arch/sh/boards/mach-migor/setup.c torvalds-linux-v3.1-rc10/arch/sh/boards/mach-migor/setup.c
--- linux-3.0/arch/sh/boards/mach-migor/setup.c	2011-06-22 15:08:12.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/mach-migor/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -214,7 +214,7 @@ static struct platform_device migor_nand
 	}
 };
 
-const static struct fb_videomode migor_lcd_modes[] = {
+static const struct fb_videomode migor_lcd_modes[] = {
 	{
 #if defined(CONFIG_SH_MIGOR_RTA_WVGA)
 		.name = "LB070WV1",
diff -NurpP --minimal linux-3.0/arch/sh/boards/mach-sdk7786/setup.c torvalds-linux-v3.1-rc10/arch/sh/boards/mach-sdk7786/setup.c
--- linux-3.0/arch/sh/boards/mach-sdk7786/setup.c	2011-04-03 18:50:36.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/mach-sdk7786/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -194,7 +194,7 @@ static int sdk7786_clk_init(void)
 		return -EINVAL;
 
 	clk = clk_get(NULL, "extal");
-	if (!clk || IS_ERR(clk))
+	if (IS_ERR(clk))
 		return PTR_ERR(clk);
 	ret = clk_set_rate(clk, 33333333);
 	clk_put(clk);
diff -NurpP --minimal linux-3.0/arch/sh/boards/mach-se/7724/setup.c torvalds-linux-v3.1-rc10/arch/sh/boards/mach-se/7724/setup.c
--- linux-3.0/arch/sh/boards/mach-se/7724/setup.c	2011-06-22 15:08:12.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/boards/mach-se/7724/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -145,7 +145,7 @@ static struct platform_device nor_flash_
 };
 
 /* LCDC */
-const static struct fb_videomode lcdc_720p_modes[] = {
+static const struct fb_videomode lcdc_720p_modes[] = {
 	{
 		.name		= "LB070WV1",
 		.sync		= 0, /* hsync and vsync are active low */
@@ -160,7 +160,7 @@ const static struct fb_videomode lcdc_72
 	},
 };
 
-const static struct fb_videomode lcdc_vga_modes[] = {
+static const struct fb_videomode lcdc_vga_modes[] = {
 	{
 		.name		= "LB070WV1",
 		.sync		= 0, /* hsync and vsync are active low */
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/fixups-cayman.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-cayman.c
--- linux-3.0/arch/sh/drivers/pci/fixups-cayman.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-cayman.c	2011-10-18 04:06:23.000000000 +0000
@@ -5,7 +5,7 @@
 #include <cpu/irq.h>
 #include "pci-sh5.h"
 
-int __init pcibios_map_platform_irq(struct pci_dev *dev, u8 slot, u8 pin)
+int __init pcibios_map_platform_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	int result = -1;
 
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/fixups-dreamcast.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-dreamcast.c
--- linux-3.0/arch/sh/drivers/pci/fixups-dreamcast.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-dreamcast.c	2011-10-18 04:06:23.000000000 +0000
@@ -64,7 +64,7 @@ static void __init gapspci_fixup_resourc
 }
 DECLARE_PCI_FIXUP_HEADER(PCI_ANY_ID, PCI_ANY_ID, gapspci_fixup_resources);
 
-int __init pcibios_map_platform_irq(struct pci_dev *dev, u8 slot, u8 pin)
+int __init pcibios_map_platform_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	/*
 	 * The interrupt routing semantics here are quite trivial.
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/fixups-landisk.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-landisk.c
--- linux-3.0/arch/sh/drivers/pci/fixups-landisk.c	2011-04-03 18:50:37.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-landisk.c	2011-10-18 04:06:23.000000000 +0000
@@ -19,7 +19,7 @@
 #define PCIMCR_MRSET_OFF	0xBFFFFFFF
 #define PCIMCR_RFSH_OFF		0xFFFFFFFB
 
-int pcibios_map_platform_irq(struct pci_dev *pdev, u8 slot, u8 pin)
+int pcibios_map_platform_irq(const struct pci_dev *pdev, u8 slot, u8 pin)
 {
 	/*
 	 * slot0: pin1-4 = irq5,6,7,8
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/fixups-r7780rp.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-r7780rp.c
--- linux-3.0/arch/sh/drivers/pci/fixups-r7780rp.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-r7780rp.c	2011-10-18 04:06:23.000000000 +0000
@@ -18,7 +18,7 @@ static char irq_tab[] __initdata = {
 	65, 66, 67, 68,
 };
 
-int __init pcibios_map_platform_irq(struct pci_dev *pdev, u8 slot, u8 pin)
+int __init pcibios_map_platform_irq(const struct pci_dev *pdev, u8 slot, u8 pin)
 {
 	return irq_tab[slot];
 }
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/fixups-rts7751r2d.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-rts7751r2d.c
--- linux-3.0/arch/sh/drivers/pci/fixups-rts7751r2d.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-rts7751r2d.c	2011-10-18 04:06:23.000000000 +0000
@@ -31,7 +31,7 @@ static char lboxre2_irq_tab[] __initdata
 	IRQ_ETH0, IRQ_ETH1, IRQ_INTA, IRQ_INTD,
 };
 
-int __init pcibios_map_platform_irq(struct pci_dev *pdev, u8 slot, u8 pin)
+int __init pcibios_map_platform_irq(const struct pci_dev *pdev, u8 slot, u8 pin)
 {
 	if (mach_is_lboxre2())
 		return lboxre2_irq_tab[slot];
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/fixups-sdk7780.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-sdk7780.c
--- linux-3.0/arch/sh/drivers/pci/fixups-sdk7780.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-sdk7780.c	2011-10-18 04:06:23.000000000 +0000
@@ -27,7 +27,7 @@ static char sdk7780_irq_tab[4][16] __ini
 	{ 68, 67, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 },
 };
 
-int __init pcibios_map_platform_irq(struct pci_dev *pdev, u8 slot, u8 pin)
+int __init pcibios_map_platform_irq(const struct pci_dev *pdev, u8 slot, u8 pin)
 {
        return sdk7780_irq_tab[pin-1][slot];
 }
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/fixups-se7751.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-se7751.c
--- linux-3.0/arch/sh/drivers/pci/fixups-se7751.c	2011-08-29 03:04:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-se7751.c	2011-10-18 04:06:23.000000000 +0000
@@ -6,7 +6,7 @@
 #include <linux/io.h>
 #include "pci-sh4.h"
 
-int __init pcibios_map_platform_irq(struct pci_dev *, u8 slot, u8 pin)
+int __init pcibios_map_platform_irq(const struct pci_dev *, u8 slot, u8 pin)
 {
         switch (slot) {
         case 0: return 13;
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/fixups-sh03.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-sh03.c
--- linux-3.0/arch/sh/drivers/pci/fixups-sh03.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-sh03.c	2011-10-18 04:06:23.000000000 +0000
@@ -3,7 +3,7 @@
 #include <linux/types.h>
 #include <linux/pci.h>
 
-int __init pcibios_map_platform_irq(struct pci_dev *dev, u8 slot, u8 pin)
+int __init pcibios_map_platform_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	int irq;
 
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/fixups-snapgear.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-snapgear.c
--- linux-3.0/arch/sh/drivers/pci/fixups-snapgear.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-snapgear.c	2011-10-18 04:06:23.000000000 +0000
@@ -18,7 +18,7 @@
 #include <linux/pci.h>
 #include "pci-sh4.h"
 
-int __init pcibios_map_platform_irq(struct pci_dev *pdev, u8 slot, u8 pin)
+int __init pcibios_map_platform_irq(const struct pci_dev *pdev, u8 slot, u8 pin)
 {
 	int irq = -1;
 
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/fixups-titan.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-titan.c
--- linux-3.0/arch/sh/drivers/pci/fixups-titan.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/fixups-titan.c	2011-10-18 04:06:23.000000000 +0000
@@ -27,7 +27,7 @@ static char titan_irq_tab[] __initdata =
 	TITAN_IRQ_USB,
 };
 
-int __init pcibios_map_platform_irq(struct pci_dev *pdev, u8 slot, u8 pin)
+int __init pcibios_map_platform_irq(const struct pci_dev *pdev, u8 slot, u8 pin)
 {
 	int irq = titan_irq_tab[slot];
 
diff -NurpP --minimal linux-3.0/arch/sh/drivers/pci/pcie-sh7786.c torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/pcie-sh7786.c
--- linux-3.0/arch/sh/drivers/pci/pcie-sh7786.c	2011-06-22 15:08:12.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/drivers/pci/pcie-sh7786.c	2011-10-18 04:06:23.000000000 +0000
@@ -466,7 +466,7 @@ static int __init pcie_init(struct sh778
 	return 0;
 }
 
-int __init pcibios_map_platform_irq(struct pci_dev *pdev, u8 slot, u8 pin)
+int __init pcibios_map_platform_irq(const struct pci_dev *pdev, u8 slot, u8 pin)
 {
         return 71;
 }
diff -NurpP --minimal linux-3.0/arch/sh/include/asm/atomic.h torvalds-linux-v3.1-rc10/arch/sh/include/asm/atomic.h
--- linux-3.0/arch/sh/include/asm/atomic.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/include/asm/atomic.h	2011-10-18 04:06:23.000000000 +0000
@@ -30,7 +30,6 @@
 #define atomic_inc_and_test(v)		(atomic_inc_return(v) == 0)
 #define atomic_sub_and_test(i,v)	(atomic_sub_return((i), (v)) == 0)
 #define atomic_dec_and_test(v)		(atomic_sub_return(1, (v)) == 0)
-#define atomic_inc_not_zero(v)		atomic_add_unless((v), 1, 0)
 
 #define atomic_inc(v)			atomic_add(1, (v))
 #define atomic_dec(v)			atomic_sub(1, (v))
@@ -39,15 +38,15 @@
 #define atomic_cmpxchg(v, o, n)		(cmpxchg(&((v)->counter), (o), (n)))
 
 /**
- * atomic_add_unless - add unless the number is a given value
+ * __atomic_add_unless - add unless the number is a given value
  * @v: pointer of type atomic_t
  * @a: the amount to add to v...
  * @u: ...unless v is equal to u.
  *
  * Atomically adds @a to @v, so long as it was not @u.
- * Returns non-zero if @v was not @u, and zero otherwise.
+ * Returns the old value of @v.
  */
-static inline int atomic_add_unless(atomic_t *v, int a, int u)
+static inline int __atomic_add_unless(atomic_t *v, int a, int u)
 {
 	int c, old;
 	c = atomic_read(v);
@@ -60,7 +59,7 @@ static inline int atomic_add_unless(atom
 		c = old;
 	}
 
-	return c != (u);
+	return c;
 }
 
 #define smp_mb__before_atomic_dec()	smp_mb()
@@ -68,7 +67,4 @@ static inline int atomic_add_unless(atom
 #define smp_mb__before_atomic_inc()	smp_mb()
 #define smp_mb__after_atomic_inc()	smp_mb()
 
-#include <asm-generic/atomic-long.h>
-#include <asm-generic/atomic64.h>
-
 #endif /* __ASM_SH_ATOMIC_H */
diff -NurpP --minimal linux-3.0/arch/sh/include/asm/delay.h torvalds-linux-v3.1-rc10/arch/sh/include/asm/delay.h
--- linux-3.0/arch/sh/include/asm/delay.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/include/asm/delay.h	2011-10-18 04:06:23.000000000 +0000
@@ -1,26 +1 @@
-#ifndef __ASM_SH_DELAY_H
-#define __ASM_SH_DELAY_H
-
-/*
- * Copyright (C) 1993 Linus Torvalds
- *
- * Delay routines calling functions in arch/sh/lib/delay.c
- */
-
-extern void __bad_udelay(void);
-extern void __bad_ndelay(void);
-
-extern void __udelay(unsigned long usecs);
-extern void __ndelay(unsigned long nsecs);
-extern void __const_udelay(unsigned long xloops);
-extern void __delay(unsigned long loops);
-
-#define udelay(n) (__builtin_constant_p(n) ? \
-	((n) > 20000 ? __bad_udelay() : __const_udelay((n) * 0x10c6ul)) : \
-	__udelay(n))
-
-#define ndelay(n) (__builtin_constant_p(n) ? \
-	((n) > 20000 ? __bad_ndelay() : __const_udelay((n) * 5ul)) : \
-	__ndelay(n))
-
-#endif /* __ASM_SH_DELAY_H */
+#include <asm-generic/delay.h>
diff -NurpP --minimal linux-3.0/arch/sh/include/asm/hw_irq.h torvalds-linux-v3.1-rc10/arch/sh/include/asm/hw_irq.h
--- linux-3.0/arch/sh/include/asm/hw_irq.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/include/asm/hw_irq.h	2011-10-18 04:06:23.000000000 +0000
@@ -3,7 +3,7 @@
 
 #include <linux/init.h>
 #include <linux/sh_intc.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 
 extern atomic_t irq_err_count;
 
diff -NurpP --minimal linux-3.0/arch/sh/include/asm/pci.h torvalds-linux-v3.1-rc10/arch/sh/include/asm/pci.h
--- linux-3.0/arch/sh/include/asm/pci.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/include/asm/pci.h	2011-10-18 04:06:23.000000000 +0000
@@ -112,7 +112,7 @@ static inline void pci_dma_burst_advice(
 #endif
 
 /* Board-specific fixup routines. */
-int pcibios_map_platform_irq(struct pci_dev *dev, u8 slot, u8 pin);
+int pcibios_map_platform_irq(const struct pci_dev *dev, u8 slot, u8 pin);
 
 extern void pcibios_resource_to_bus(struct pci_dev *dev,
 	struct pci_bus_region *region, struct resource *res);
diff -NurpP --minimal linux-3.0/arch/sh/include/asm/ptrace.h torvalds-linux-v3.1-rc10/arch/sh/include/asm/ptrace.h
--- linux-3.0/arch/sh/include/asm/ptrace.h	2011-08-29 03:04:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/include/asm/ptrace.h	2011-10-18 04:06:23.000000000 +0000
@@ -45,8 +45,6 @@
 #define GET_FP(regs)	((regs)->regs[14])
 #define GET_USP(regs)	((regs)->regs[15])
 
-extern void show_regs(struct pt_regs *);
-
 #define arch_has_single_step()	(1)
 
 /*
@@ -125,7 +123,7 @@ static inline unsigned long regs_get_ker
 struct perf_event;
 struct perf_sample_data;
 
-extern void ptrace_triggered(struct perf_event *bp, int nmi,
+extern void ptrace_triggered(struct perf_event *bp,
 		      struct perf_sample_data *data, struct pt_regs *regs);
 
 #define task_pt_regs(task) \
diff -NurpP --minimal linux-3.0/arch/sh/include/asm/smp.h torvalds-linux-v3.1-rc10/arch/sh/include/asm/smp.h
--- linux-3.0/arch/sh/include/asm/smp.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/include/asm/smp.h	2011-10-18 04:06:23.000000000 +0000
@@ -8,7 +8,7 @@
 #ifdef CONFIG_SMP
 
 #include <linux/spinlock.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/current.h>
 #include <asm/percpu.h>
 
diff -NurpP --minimal linux-3.0/arch/sh/include/cpu-sh3/cpu/serial.h torvalds-linux-v3.1-rc10/arch/sh/include/cpu-sh3/cpu/serial.h
--- linux-3.0/arch/sh/include/cpu-sh3/cpu/serial.h	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/include/cpu-sh3/cpu/serial.h	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,10 @@
+#ifndef __CPU_SH3_SERIAL_H
+#define __CPU_SH3_SERIAL_H
+
+#include <linux/serial_sci.h>
+
+extern struct plat_sci_port_ops sh770x_sci_port_ops;
+extern struct plat_sci_port_ops sh7710_sci_port_ops;
+extern struct plat_sci_port_ops sh7720_sci_port_ops;
+
+#endif /* __CPU_SH3_SERIAL_H */
diff -NurpP --minimal linux-3.0/arch/sh/include/cpu-sh4a/cpu/serial.h torvalds-linux-v3.1-rc10/arch/sh/include/cpu-sh4a/cpu/serial.h
--- linux-3.0/arch/sh/include/cpu-sh4a/cpu/serial.h	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/include/cpu-sh4a/cpu/serial.h	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,7 @@
+#ifndef __CPU_SH4A_SERIAL_H
+#define __CPU_SH4A_SERIAL_H
+
+/* arch/sh/kernel/cpu/sh4a/serial-sh7722.c */
+extern struct plat_sci_port_ops sh7722_sci_port_ops;
+
+#endif /* __CPU_SH4A_SERIAL_H */
diff -NurpP --minimal linux-3.0/arch/sh/kernel/cpu/clock-cpg.c torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/clock-cpg.c
--- linux-3.0/arch/sh/kernel/cpu/clock-cpg.c	2011-06-22 15:08:13.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/clock-cpg.c	2011-10-18 04:06:23.000000000 +0000
@@ -35,8 +35,6 @@ static struct clk *onchip_clocks[] = {
 	&cpu_clk,
 };
 
-#define CLKDEV_CON_ID(_id, _clk) { .con_id = _id, .clk = _clk }
-
 static struct clk_lookup lookups[] = {
 	/* main clocks */
 	CLKDEV_CON_ID("master_clk", &master_clk),
diff -NurpP --minimal linux-3.0/arch/sh/kernel/cpu/sh3/Makefile torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/Makefile
--- linux-3.0/arch/sh/kernel/cpu/sh3/Makefile	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/Makefile	2011-10-18 04:06:23.000000000 +0000
@@ -7,15 +7,15 @@ obj-y	:= ex.o probe.o entry.o setup-sh3.
 obj-$(CONFIG_HIBERNATION)		+= swsusp.o
 
 # CPU subtype setup
-obj-$(CONFIG_CPU_SUBTYPE_SH7705)	+= setup-sh7705.o
-obj-$(CONFIG_CPU_SUBTYPE_SH7706)	+= setup-sh770x.o
-obj-$(CONFIG_CPU_SUBTYPE_SH7707)	+= setup-sh770x.o
-obj-$(CONFIG_CPU_SUBTYPE_SH7708)	+= setup-sh770x.o
-obj-$(CONFIG_CPU_SUBTYPE_SH7709)	+= setup-sh770x.o
-obj-$(CONFIG_CPU_SUBTYPE_SH7710)	+= setup-sh7710.o
-obj-$(CONFIG_CPU_SUBTYPE_SH7712)	+= setup-sh7710.o
-obj-$(CONFIG_CPU_SUBTYPE_SH7720)	+= setup-sh7720.o
-obj-$(CONFIG_CPU_SUBTYPE_SH7721)	+= setup-sh7720.o
+obj-$(CONFIG_CPU_SUBTYPE_SH7705)	+= setup-sh7705.o serial-sh770x.o
+obj-$(CONFIG_CPU_SUBTYPE_SH7706)	+= setup-sh770x.o serial-sh770x.o
+obj-$(CONFIG_CPU_SUBTYPE_SH7707)	+= setup-sh770x.o serial-sh770x.o
+obj-$(CONFIG_CPU_SUBTYPE_SH7708)	+= setup-sh770x.o serial-sh770x.o
+obj-$(CONFIG_CPU_SUBTYPE_SH7709)	+= setup-sh770x.o serial-sh770x.o
+obj-$(CONFIG_CPU_SUBTYPE_SH7710)	+= setup-sh7710.o serial-sh7710.o
+obj-$(CONFIG_CPU_SUBTYPE_SH7712)	+= setup-sh7710.o serial-sh7710.o
+obj-$(CONFIG_CPU_SUBTYPE_SH7720)	+= setup-sh7720.o serial-sh7720.o
+obj-$(CONFIG_CPU_SUBTYPE_SH7721)	+= setup-sh7720.o serial-sh7720.o
 
 # Primary on-chip clocks (common)
 clock-$(CONFIG_CPU_SH3)			:= clock-sh3.o
diff -NurpP --minimal linux-3.0/arch/sh/kernel/cpu/sh3/serial-sh770x.c torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/serial-sh770x.c
--- linux-3.0/arch/sh/kernel/cpu/sh3/serial-sh770x.c	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/serial-sh770x.c	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,33 @@
+#include <linux/serial_sci.h>
+#include <linux/serial_core.h>
+#include <linux/io.h>
+#include <cpu/serial.h>
+
+#define SCPCR 0xA4000116
+#define SCPDR 0xA4000136
+
+static void sh770x_sci_init_pins(struct uart_port *port, unsigned int cflag)
+{
+	unsigned short data;
+
+	/* We need to set SCPCR to enable RTS/CTS */
+	data = __raw_readw(SCPCR);
+	/* Clear out SCP7MD1,0, SCP6MD1,0, SCP4MD1,0*/
+	__raw_writew(data & 0x0fcf, SCPCR);
+
+	if (!(cflag & CRTSCTS)) {
+		/* We need to set SCPCR to enable RTS/CTS */
+		data = __raw_readw(SCPCR);
+		/* Clear out SCP7MD1,0, SCP4MD1,0,
+		   Set SCP6MD1,0 = {01} (output)  */
+		__raw_writew((data & 0x0fcf) | 0x1000, SCPCR);
+
+		data = __raw_readb(SCPDR);
+		/* Set /RTS2 (bit6) = 0 */
+		__raw_writeb(data & 0xbf, SCPDR);
+	}
+}
+
+struct plat_sci_port_ops sh770x_sci_port_ops = {
+	.init_pins	= sh770x_sci_init_pins,
+};
diff -NurpP --minimal linux-3.0/arch/sh/kernel/cpu/sh3/serial-sh7710.c torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/serial-sh7710.c
--- linux-3.0/arch/sh/kernel/cpu/sh3/serial-sh7710.c	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/serial-sh7710.c	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,20 @@
+#include <linux/serial_sci.h>
+#include <linux/serial_core.h>
+#include <linux/io.h>
+#include <cpu/serial.h>
+
+#define PACR 0xa4050100
+#define PBCR 0xa4050102
+
+static void sh7710_sci_init_pins(struct uart_port *port, unsigned int cflag)
+{
+	if (port->mapbase == 0xA4400000) {
+		__raw_writew(__raw_readw(PACR) & 0xffc0, PACR);
+		__raw_writew(__raw_readw(PBCR) & 0x0fff, PBCR);
+	} else if (port->mapbase == 0xA4410000)
+		__raw_writew(__raw_readw(PBCR) & 0xf003, PBCR);
+}
+
+struct plat_sci_port_ops sh7710_sci_port_ops = {
+	.init_pins	= sh7710_sci_init_pins,
+};
diff -NurpP --minimal linux-3.0/arch/sh/kernel/cpu/sh3/serial-sh7720.c torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/serial-sh7720.c
--- linux-3.0/arch/sh/kernel/cpu/sh3/serial-sh7720.c	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/serial-sh7720.c	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,37 @@
+#include <linux/serial_sci.h>
+#include <linux/serial_core.h>
+#include <linux/io.h>
+#include <cpu/serial.h>
+#include <asm/gpio.h>
+
+static void sh7720_sci_init_pins(struct uart_port *port, unsigned int cflag)
+{
+	unsigned short data;
+
+	if (cflag & CRTSCTS) {
+		/* enable RTS/CTS */
+		if (port->mapbase == 0xa4430000) { /* SCIF0 */
+			/* Clear PTCR bit 9-2; enable all scif pins but sck */
+			data = __raw_readw(PORT_PTCR);
+			__raw_writew((data & 0xfc03), PORT_PTCR);
+		} else if (port->mapbase == 0xa4438000) { /* SCIF1 */
+			/* Clear PVCR bit 9-2 */
+			data = __raw_readw(PORT_PVCR);
+			__raw_writew((data & 0xfc03), PORT_PVCR);
+		}
+	} else {
+		if (port->mapbase == 0xa4430000) { /* SCIF0 */
+			/* Clear PTCR bit 5-2; enable only tx and rx  */
+			data = __raw_readw(PORT_PTCR);
+			__raw_writew((data & 0xffc3), PORT_PTCR);
+		} else if (port->mapbase == 0xa4438000) { /* SCIF1 */
+			/* Clear PVCR bit 5-2 */
+			data = __raw_readw(PORT_PVCR);
+			__raw_writew((data & 0xffc3), PORT_PVCR);
+		}
+	}
+}
+
+struct plat_sci_port_ops sh7720_sci_port_ops = {
+	.init_pins	= sh7720_sci_init_pins,
+};
diff -NurpP --minimal linux-3.0/arch/sh/kernel/cpu/sh3/setup-sh7705.c torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/setup-sh7705.c
--- linux-3.0/arch/sh/kernel/cpu/sh3/setup-sh7705.c	2011-04-03 18:50:38.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/setup-sh7705.c	2011-10-18 04:06:23.000000000 +0000
@@ -15,6 +15,7 @@
 #include <linux/serial_sci.h>
 #include <linux/sh_timer.h>
 #include <asm/rtc.h>
+#include <cpu/serial.h>
 
 enum {
 	UNUSED = 0,
@@ -75,6 +76,8 @@ static struct plat_sci_port scif0_platfo
 	.scbrr_algo_id	= SCBRR_ALGO_4,
 	.type		= PORT_SCIF,
 	.irqs		= { 56, 56, 56 },
+	.ops		= &sh770x_sci_port_ops,
+	.regtype	= SCIx_SH7705_SCIF_REGTYPE,
 };
 
 static struct platform_device scif0_device = {
@@ -92,6 +95,8 @@ static struct plat_sci_port scif1_platfo
 	.scbrr_algo_id	= SCBRR_ALGO_4,
 	.type		= PORT_SCIF,
 	.irqs		= { 52, 52, 52 },
+	.ops		= &sh770x_sci_port_ops,
+	.regtype	= SCIx_SH7705_SCIF_REGTYPE,
 };
 
 static struct platform_device scif1_device = {
diff -NurpP --minimal linux-3.0/arch/sh/kernel/cpu/sh3/setup-sh770x.c torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/setup-sh770x.c
--- linux-3.0/arch/sh/kernel/cpu/sh3/setup-sh770x.c	2011-04-03 18:50:38.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/setup-sh770x.c	2011-10-18 04:06:23.000000000 +0000
@@ -19,6 +19,7 @@
 #include <linux/serial.h>
 #include <linux/serial_sci.h>
 #include <linux/sh_timer.h>
+#include <cpu/serial.h>
 
 enum {
 	UNUSED = 0,
@@ -108,11 +109,14 @@ static struct platform_device rtc_device
 
 static struct plat_sci_port scif0_platform_data = {
 	.mapbase	= 0xfffffe80,
+	.port_reg	= 0xa4000136,
 	.flags		= UPF_BOOT_AUTOCONF,
 	.scscr		= SCSCR_TE | SCSCR_RE,
 	.scbrr_algo_id	= SCBRR_ALGO_2,
 	.type		= PORT_SCI,
 	.irqs		= { 23, 23, 23, 0 },
+	.ops		= &sh770x_sci_port_ops,
+	.regshift	= 1,
 };
 
 static struct platform_device scif0_device = {
@@ -132,6 +136,8 @@ static struct plat_sci_port scif1_platfo
 	.scbrr_algo_id	= SCBRR_ALGO_2,
 	.type		= PORT_SCIF,
 	.irqs		= { 56, 56, 56, 56 },
+	.ops		= &sh770x_sci_port_ops,
+	.regtype	= SCIx_SH3_SCIF_REGTYPE,
 };
 
 static struct platform_device scif1_device = {
@@ -146,11 +152,14 @@ static struct platform_device scif1_devi
     defined(CONFIG_CPU_SUBTYPE_SH7709)
 static struct plat_sci_port scif2_platform_data = {
 	.mapbase	= 0xa4000140,
+	.port_reg	= SCIx_NOT_SUPPORTED,
 	.flags		= UPF_BOOT_AUTOCONF,
 	.scscr		= SCSCR_TE | SCSCR_RE,
 	.scbrr_algo_id	= SCBRR_ALGO_2,
 	.type		= PORT_IRDA,
 	.irqs		= { 52, 52, 52, 52 },
+	.ops		= &sh770x_sci_port_ops,
+	.regshift	= 1,
 };
 
 static struct platform_device scif2_device = {
diff -NurpP --minimal linux-3.0/arch/sh/kernel/cpu/sh3/setup-sh7720.c torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/setup-sh7720.c
--- linux-3.0/arch/sh/kernel/cpu/sh3/setup-sh7720.c	2011-04-03 18:50:38.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/sh/kernel/cpu/sh3/setup-sh7720.c	2011-10-18 04:06:23.000000000 +0000
@@ -20,6 +20,7 @@
 #include <linux/serial_sci.h>
 #include <linux/sh_timer.h>
 #include <asm/rtc.h>
+#include <cpu/serial.h>
 
 static struct resource rtc_resources[] = {
 	[0] = {
@@ -55,6 +56,8 @@ static struct plat_sci_port scif0_platfo
 	.scbrr_algo_id	= SCBRR_ALGO_4,
 	.type		= PORT_SCIF,
 	.irqs		= { 80, 80, 80, 80 },
+	.ops		= &sh7720_sci_port_ops,
+	.regtype	= SCIx_SH7705_SCIF_REGTYPE,
 };
 
 static struct platform_device scif0_device = {
@@ -72,6 +75,8 @@ static struct plat_sci_port scif1_platfo
 	.scbrr_algo_id	= SCBRR_ALGO_4,
 	.type		= PORT_SCIF,
 	.irqs           = { 81, 81, 81, 81 },
+	.ops		= &sh7720_sci_port_ops,
+	.regtype	= SCIx_SH7705_SCIF_REGTYPE,
 };
 
 static struct platform_device scif1_device = {
